searchNodes=[{"doc":"Reather is the combined form of Reader and Either monad. A Reather wrapps an environment and the child functions can use the environment to access the values. The evaluation of Reather is lazy, so it's never computed until explicitly call Reather.run/2 .","ref":"Reather.html","title":"Reather","type":"module"},{"doc":"Get the current environment.","ref":"Reather.html#ask/0","title":"Reather.ask/0","type":"function"},{"doc":"Inspect the reather. Warning : It runs the reather. So, the provided reather should not have side effects.","ref":"Reather.html#inspect/2","title":"Reather.inspect/2","type":"function"},{"doc":"Map a function to the reather. map is lazy, so it's never computed until explicitly call Reather.run/2 . Examples iex&gt; r = reather do ...&gt; x &lt;- { :ok , 1 } ...&gt; x ...&gt; end iex&gt; r ...&gt; |&gt; Reather . map ( fn x -&gt; x + 1 end ) ...&gt; |&gt; Reather . run ( ) { :ok , 2 }","ref":"Reather.html#map/2","title":"Reather.map/2","type":"function"},{"doc":"Create a new Reather from the function.","ref":"Reather.html#new/1","title":"Reather.new/1","type":"function"},{"doc":"Create a Reather from the value.","ref":"Reather.html#of/1","title":"Reather.of/1","type":"function"},{"doc":"Run the reather.","ref":"Reather.html#run/2","title":"Reather.run/2","type":"function"},{"doc":"Transform a list of reathers to an reather of a list. This operation is lazy, so it's never computed until explicitly call Reather.run/2 . Examples iex&gt; r = [ { :ok , 1 } , { :ok , 2 } , { :ok , 3 } ] ...&gt; |&gt; Enum . map ( &amp; Reather . of / 1 ) ...&gt; |&gt; Reather . traverse ( ) iex&gt; Reather . run ( r ) { :ok , [ 1 , 2 , 3 ] } iex&gt; r = [ { :ok , 1 } , { :error , &quot;error&quot; } , { :ok , 3 } ] ...&gt; |&gt; Enum . map ( &amp; Reather . of / 1 ) ...&gt; |&gt; Reather . traverse ( ) iex&gt; Reather . run ( r ) { :error , &quot;error&quot; }","ref":"Reather.html#traverse/1","title":"Reather.traverse/1","type":"function"},{"doc":"Create a Reather from the value. If the value is Reather , it will be returned as is. Examples iex&gt; % Reather { } = Reather . wrap ( :ok ) iex&gt; r = % Reather { } iex&gt; ^ r = Reather . wrap ( r )","ref":"Reather.html#wrap/1","title":"Reather.wrap/1","type":"function"},{"doc":"","ref":"Reather.Either.html","title":"Reather.Either","type":"module"},{"doc":"","ref":"Reather.Either.html#error/1","title":"Reather.Either.error/1","type":"function"},{"doc":"Map a function to the either. If the either is ok , the function is applied to the value. If the either is error , it returns as is. Examples iex&gt; { :ok , 1 } |&gt; Either . map ( fn x -&gt; x + 1 end ) { :ok , 2 } iex&gt; { :error , 1 } |&gt; Either . map ( fn x -&gt; x + 1 end ) { :error , 1 }","ref":"Reather.Either.html#map/2","title":"Reather.Either.map/2","type":"function"},{"doc":"Convert a value into ok or error tuple. The result is a tuple having an :ok or :error atom for the first element, and a value for the second element. Examples iex&gt; Reather.Either . new ( :ok ) { :ok , nil } iex&gt; Reather.Either . new ( :error ) { :error , nil } iex&gt; Reather.Either . new ( { :ok , 3 } ) { :ok , 3 } iex&gt; Reather.Either . new ( { :error , &quot;error!&quot; } ) { :error , &quot;error!&quot; } iex&gt; Reather.Either . new ( { :ok , 1 , 2 } ) { :ok , { 1 , 2 } } iex&gt; Reather.Either . new ( { :error , &quot;error&quot; , :invalid } ) { :error , { &quot;error&quot; , :invalid } } iex&gt; Reather.Either . new ( { 1 , 2 } ) { :ok , { 1 , 2 } } iex&gt; Reather.Either . new ( { } ) { :ok , { } } iex&gt; Reather.Either . new ( 1 ) { :ok , 1 } iex&gt; [ 1 , :error ] ...&gt; |&gt; Enum . map ( fn x -&gt; ...&gt; Reather.Either . new ( x , &quot;error&quot; ) ...&gt; end ) [ { :ok , 1 } , { :error , &quot;error&quot; } ]","ref":"Reather.Either.html#new/2","title":"Reather.Either.new/2","type":"function"},{"doc":"Transform a list of eithers to an either of a list. If any of the eithers is error , the result is error . Examples iex&gt; [ { :ok , 1 } , { :ok , 2 } ] |&gt; Either . traverse ( ) { :ok , [ 1 , 2 ] } iex&gt; [ { :ok , 1 } , { :error , &quot;error!&quot; } , { :ok , 2 } ] ...&gt; |&gt; Reather.Either . traverse ( ) { :error , &quot;error!&quot; }","ref":"Reather.Either.html#traverse/1","title":"Reather.Either.traverse/1","type":"function"},{"doc":"","ref":"Reather.Macros.html","title":"Reather.Macros","type":"module"},{"doc":"","ref":"Reather.Macros.html#reather/1","title":"Reather.Macros.reather/1","type":"macro"},{"doc":"Declare a reather.","ref":"Reather.Macros.html#reather/2","title":"Reather.Macros.reather/2","type":"macro"},{"doc":"Declare a private reather.","ref":"Reather.Macros.html#reatherp/2","title":"Reather.Macros.reatherp/2","type":"macro"},{"doc":"Reather is a shortcut of Reader + Either monads pattern. It makes you define and unwrap the Reather easiliy by using the reather macro. The original idea is from jechol/reather , and this is a lite version without using Witchcraft .","ref":"readme.html","title":"ReatherLite","type":"extras"},{"doc":"def deps do [ { :reather_lite , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"ReatherLite - Installation","type":"extras"},{"doc":"Basic usage reather macro defines a function returns Reather . defmodule Target do use Reather reather foo ( a , b ) do a + b end end iex&gt; Target . foo ( 1 , 1 ) % Reather { ... } Since the Reather is lazily evaluated, it does nothing until call Reather.run/2 . iex&gt; Target . foo ( 1 , 1 ) |&gt; Reather . run ( ) { :ok , 2 } The result of Reather is always {:ok, value} or {:error, error} . In a reather block, the ok tuple will be automatically unwrapped by a &lt;- operator. defmodule Target do use Reather reather foo ( ) do a &lt;- { :ok , 1 } # a = 1 { b , c } &lt;- { :ok , 2 , 3 } # b = 2, c = 3 d = nil ^ d &lt;- :ok a + b + c end end iex&gt; Target . foo ( ) |&gt; Reather . run ( ) { :ok , 6 } Also, a Reather unwrap into a value with a &lt;- operator. defmodule Target do use Reather reather foo ( a , b ) do x &lt;- bar ( a ) # The result of bar(a) is {:ok, a + 1} and x will be bound to a + 1. x + b end reather bar ( a ) , do : a + 1 end iex&gt; Target . foo ( 1 , 1 ) |&gt; Reather . run ( ) { :ok , 3 } Because of the either monad, when the &lt;- operator meets an error tuple, the reather will return it immediately. defmodule Target do use Reather reather foo ( ) do x &lt;- { :ok , 1 } y &lt;- { :error , &quot;asdf&quot; , 1 } # foo will return {:error, {&quot;asdf&quot;, 1}} x + y end end iex&gt; Target . foo ( ) |&gt; Reather . run ( ) { :error , { &quot;asdf&quot; , 1 } } Inline reather reather also can be inlined. iex&gt; r = ...&gt; reather do ...&gt; x &lt;- { :ok , 1 } ...&gt; y &lt;- { :ok , 2 } ...&gt; ...&gt; x + y ...&gt; end % Reather { ... } iex&gt; r |&gt; Reather . run ( ) { :ok , 3 } Reather.ask Because of the Reather is a combination of reader and either monads, it also provides an environment. The providen environment can be accessed with Reather.ask/0 . defmodule Target do use Reather reather foo ( ) do %{ a : a } &lt;- Reather . ask ( ) %{ b : b } &lt;- Reather . ask ( ) 1 + a + b end reather bar ( ) do x &lt;- foo ( ) x + 1 end end iex&gt; Target . foo ( ) |&gt; Reather . run ( %{ a : 10 , b : 100 } ) { :ok , 111 } # The environment can be accessed in nested reathers. iex&gt; Target . bar ( ) |&gt; Reather . run ( %{ a : 10 , b : 100 } ) { :ok , 112 } reatherp If you want to define a private reather, use reatherp macro instead. defmodule Target do use Reather reatherp foo ( ) do 1 end end Reather.map You can map a function to a Reather . The given function will be applied lazily when the result of the reather is an ok tuple. defmodule Target do use Reather reather foo ( ) do x &lt;- { :ok , 1 } x end reather bar ( ) do x &lt;- { :error , 1 } x end end iex&gt; Target . foo ( ) ...&gt; |&gt; Reather . map ( fn x -&gt; x + 1 end ) ...&gt; |&gt; Reather . run ( ) { :ok , 2 } iex&gt; Target . bar ( ) ...&gt; |&gt; Reather . map ( fn x -&gt; x + 1 end ) ...&gt; |&gt; Reather . run ( ) { :error , 1 } Reather.traverse Transform a list of reathers to an reather of a list. This operation is lazy, so it's never computed until explicitly call Reather.run/2 . iex&gt; r = [ { :ok , 1 } , { :ok , 2 } , { :ok , 3 } ] ...&gt; |&gt; Enum . map ( &amp; Reather . of / 1 ) # Make reathers return each elements. ...&gt; |&gt; Reather . traverse ( ) iex&gt; Reather . run ( r ) { :ok , [ 1 , 2 , 3 ] } iex&gt; r = [ { :ok , 1 } , { :error , &quot;error&quot; } , { :ok , 3 } ] ...&gt; |&gt; Enum . map ( &amp; Reather . of / 1 ) # Make reathers return each elements. ...&gt; |&gt; Reather . traverse ( ) iex&gt; Reather . run ( r ) { :error , &quot;error&quot; } Either.new Convert a value into ok or error tuple. The result is a tuple having an :ok or :error atom for the first element, and a value for the second element. Either.error Make an error tuple from a value. Either.map map a function to an either tuple. The given function will be applied lazily when the either is an ok tuple. Either.traverse Transform a list of eithers to an either of a list. If any of the eithers is error , the result is error . iex&gt; [ { :ok , 1 } , { :ok , 2 } ] |&gt; Either . traverse ( ) { :ok , [ 1 , 2 ] } iex&gt; [ { :ok , 1 } , { :error , &quot;error!&quot; } , { :ok , 2 } ] ...&gt; |&gt; Reather.Either . traverse ( ) { :error , &quot;error!&quot; }","ref":"readme.html#usage","title":"ReatherLite - Usage","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"ReatherLite - LICENSE","type":"extras"},{"doc":"MIT License Copyright (c) 2022 Seokmin Hong Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]